/**
 * 页面处理 依赖HZTOLatinConvertor.js STConvertor.js
 */
PageHZTOLatinController= Class.create();
Class.register(PageHZTOLatinController, "html.PageHZTOLatinController");
PageHZTOLatinController.version="雨水";
PageHZTOLatinController.construct = function($self, $class)
{
	this.dictionaryConfig;
	this.STConvertor;
	this.hz2latinConvertor;
	this.pageSettingConfig ;
	this.hzContainer;
	this.latinContainer;
	this.settingController;
	
	this.initialize = function(dcfg)
	{
	
		// 初始化词典
		$self.dictionaryConfig = dcfg;
		var factory = Class.get("asu.cantonese.DictFactory").create();
		$self.dictionaryConfig.each(function(cfg)
		{
			alert(cfg.id);
			dict = Class.get(cfg.id).create();
			dict.registerFactory(dict.getName(), factory);
		});
	
		// 初始化繁简转换器
		$self.STConvertor = Class.get("asu.utils.SimpleSTConvertor").create();
		
		// 初始化拉丁转换器
		$self.hz2latinConvertor = Class.get("asu.cantonese.HZTOLatinConvertor").create(factory);
		
		$self.pageSettingConfig = {data:"",
								format:HZTOLatinConvertor.formatType.lowercase,
								isJengTai:true,
								isSymblos:true,
								dictcode :"JyutpingWithoutTones",	
								dictname :"无调粤拼"};
		
	}

	/**
	 * 更新容器数据
	 * */
	this.update = function(container, data)
	{
		var obj = container;
		if (typeof container == "string") {
			obj = $(container);
		}
		obj.value = data;
	}
	
	/**
	 * 設置拉丁容器
	 */
	this.setLatinContainer = function(container)
	{
		if (typeof(container) == "string") {
			$self.latinContainer = $(container);
		} else {
			$self.latinContainer = container;
		}
	}
	
	/**
	 * 設置漢字容器
	 */
	this.setHzContainer = function(container)
	{
		if (typeof(container) == "string") {
			$self.hzContainer = $(container);
		} else {
			$self.hzContainer = container;
		}
	}
	
	/**
	 * 設置参数容器
	 */
	this.setSettingContainer = function(container)
	{
		if ($self.settingController) {
			$self.settingController.setSettingContainer(container);
		} else {
			$self.settingController = Class.get("html.SettingController").create(container);
		}
	}
	
	/**
	 * 获取参数容器
	 */
	 this.getSettingContainer = function()
	 {
		return  $self.settingController.getSettingContainer();
	 }
	 
	/**
	 * 轉換
	 */
	this.convert = function()
	{
		if ($self.pageSettingConfig.isJengTai) {
			$self.pageSettingConfig.data = $self.STConvertor.traditionalized($F($self.hzContainer));
		} else {
			$self.pageSettingConfig.data = $F($self.hzContainer);
		}
		$self.update($self.latinContainer, $self.hz2latinConvertor.convert($self.pageSettingConfig));
	}

	/**
	 * 復制結果到剪貼板
	 */
	this.copyResultToClipboard = function()
	{
		
		var obj = $self.latinContainer;
		if (obj) {
// 只适合IE
//		obj.select();
//		js = obj.createTextRange();
//		js.execCommand("Copy");
			// 使用jsjava包装类
			ClipboardUtils.copyTextToClipboard($F(obj));
		}

	}

	/**
	 * 直接轉換剪貼板上的漢字
	 */
	this.convertFormClipboard = function()
	{
		var data = ClipboardUtils.getTextFromClipboard();
		if ($self.pageSettingConfig.isJengTai) {
			$self.pageSettingConfig.data = $self.STConvertor.traditionalized(data);
		} else {
			$self.pageSettingConfig.data = data;
		}
		$self.update($self.latinContainer, $self.hz2latinConvertor.convert($self.pageSettingConfig));
	}

	/**
	 * 從剪貼板復制漢字到漢字容器
	 */
	this.pasteFormClipboard = function()
	{
		var obj = $self.hzContainer;
		if (obj) {
//			$self.hzContainer.select();
//			js = $self.hzContainer.createTextRange();
//			js.execCommand("Paste");
			var data = ClipboardUtils.getTextFromClipboard();
			obj.value = data;
		}
	}

	/**
	 * 剪貼轉換結果到剪貼板
	 */
	this.cutResultToClipboard = function()
	{
		var obj = $self.latinContainer;
		if (obj) {
//			obj.select();
//			js = obj.createTextRange();
//			js.execCommand("Cut");
			ClipboardUtils.copyTextToClipboard($F(obj));
			obj.value = "";
		}
	}

	/**
	 * 設置是否轉換大小寫
	 */
	this.doCheck = function()
	{
		var obj = document.all("chbx");
		if (obj.checked) {
			$self.pageSettingConfig.format = HZTOLatinConvertor.formatType.uppercase;
		} else {
			$self.pageSettingConfig.format = HZTOLatinConvertor.formatType.lowercase;
		}
	}

	/**
	 * 打开參數對話框
	 */
	this.onSetting = function() 
	{
		try {
			var container = $self.getSettingContainer();
			container.show();
		} catch (E) {
			alert(E.message ? E.message : E.description);
		}
	
	}
	
	/**
	 * 退出
	 */
	this.exit = function()
	{
		if (window.confirm("是否要退出程序 ? ")) {
			window.opener = null
			window.open('', '_parent', '');
			window.close();
		}
	}

	this.clean = function()
	{
//		window.clipboardData.setData('Text', '');
//		document.all("LATIN").value = '';
//		document.all("HZ").value = '';
		$self.latinContainer.value = "";
		$self.hzContainer.value = "";
		ClipboardUtils.copyTextToClipboard("");
	}

}


SettingController = Class.create();
SettingController.register("html.SettingController");
SettingController.version="雨水";
SettingController.construct = function($self, $class)
{
	this.settingContainer;
	
	
	this.initialize = function(container)
	{
		$self.setSettingContainer (container);
	}
	
	this.setSettingContainer = function (container) 
	{
		if (container != undefined && container != null) {
			if (typeof(container) == "string") {
				$self.settingContainer = $(container);
			} else {
				$self.settingContainer = container;
			}
		}
	
	}
	
	this.getSettingContainer = function() 
	{
		if  ($self.settingContainer) {
				return  $self.settingContainer;
		} else {
			var err = new Error("没有设置参数容器，请检查代码！！！");
			if (!err.message) {
				err.message = "没有设置参数容器，请检查代码！！！";
			}
			throw err;
		}
	}
}
