/*
 * 描述：通用类。
 * 作者：Suk Hònzèon
 * 版本：1.0
 *
 * 依赖：modello.js
 *
 */
CommonClazz = Class.create();
CommonClazz.author = "Suk Hònjèon";
CommonClazz.version = "1.0";
CommonClazz.copyright = "GPL 3";
CommonClazz.getContextPath = function () {
	var rootpath = document.location.href;
	rootpath = rootpath.substring(rootpath.indexOf("//") + 2, rootpath.length);
	rootpath = rootpath.substring(rootpath.indexOf("/") + 1, rootpath.length);
	rootpath = "/" + rootpath.substring(0, rootpath.indexOf("/"));
	return rootpath;
};


/*
 * 获取非空值
 */
CommonClazz.getNotNullValue = function(obj, defaultvalue) {
	var _default = "";
	if (arguments.length == 0 || arguments.length > 2) {
		alert("This function proto is getNotNullValue(obj, defaultvalue).");
		return ;
	}

	if (arguments.length == 2) {
		_default = defaultvalue;
	}

	if (obj == null || obj == undefined ) {
		return _default;
	} else {
		return trim(obj);
	}
};

CommonClazz.isEmpty = function (data) {
	if (data == null || data == '' || data == undefined) {
		return true;
	}

	return false;
};

CommonClazz.isNotEmpty = function (data) {
	return !this.isEmpty(data);
};

CommonClazz.SetWinHeight = function (obj) {
	 var win=obj;
	 if (document.getElementById)
	 {
	   if (win && !window.opera)
	   {
		if (win.contentDocument && win.contentDocument.body.offsetHeight)
			win.height = win.contentDocument.body.offsetHeight;
		else if(win.Document && win.Document.body.scrollHeight)
			win.height = win.Document.body.scrollHeight;
	   }
	 }
};

CommonClazz.isUrlLink = function(h) {
	if (!h) {
		return false;
	}
	var as = ["HREF", "ONCLICK", "INPUT"];
	var h1 = h.toUpperCase();
	for (var i = 0; i < as.length; i++) {
		var t = as[i];
		if (h1.indexOf(t) != -1) {
			return true;
		}
	}
	return false;
};

/********************
 * 取窗口滚动条高度 
 ******************/
CommonClazz.getScrollTop = function(obj)
{
	var scrollTop=0;
	
	if(obj == window.parent.document.body ){
		scrollTop=window.parent.document.body.scrollTop;
		 return scrollTop;   
	}
	
	if(obj){
		scrollTop=document.body.scrollTop;
	}else{
		 if(document.documentElement&&document.documentElement.scrollTop)
		{
			scrollTop=document.documentElement.scrollTop;
		}
		else if(document.body)
		{
			scrollTop=document.body.scrollTop;
		}
	}
	 return scrollTop;   
}


/********************
 * 取窗口可视范围的高度 
 *******************/
CommonClazz.getClientHeight = function()
{
	var clientHeight=0;
	if(document.body.clientHeight&&document.documentElement.clientHeight)
	{
		var clientHeight = (document.body.clientHeight<document.documentElement.clientHeight)?document.body.clientHeight:document.documentElement.clientHeight;        
	}
	else
	{
		var clientHeight = (document.body.clientHeight>document.documentElement.clientHeight)?document.body.clientHeight:document.documentElement.clientHeight;    
	}
	return clientHeight;
}

/********************
 * 取文档内容实际高度 
 *******************/
CommonClazz.getScrollHeight = function()
{
	return Math.max(document.body.scrollHeight,document.documentElement.scrollHeight);
}

CommonClazz.getElPosition = function(o)
{
	//获取元素绝对位置 
	var   $x=$y=0; 
	do{ 
		$x   +=   o.offsetLeft; 
		$y   +=   o.offsetTop; 
	}while   ((o   =   o.offsetParent)   &&   o.tagName   !=   "BODY "); 
	$y += 2 ;
	return   { x :$x,y:$y   }; 
}

CommonClazz.getMousePosition = function(evt)
{
	if (evt.pageX&&evt.pageY){
		return {x:evt.pageX , y:evt.pageY} ;
	}
	else if ( evt.clientX && evt.clientY){
		var _x = evt.clientX + (document.documentElement.scrollLeft ?
		document.documentElement.scrollLeft :
		document.body.scrollLeft);
		var _y = evt.clientY + (document.documentElement.scrollTop ?
	   document.documentElement.scrollTop :
	   document.body.scrollTop);
	   return {x:_x , y:_y} ;
	}
	return null;
};

//特殊字符转义
CommonClazz.specailCharConvert = function(val)
{//& a c u t e ; 
	var specialChar = {a:["&", "&amp;"], b:["<", "&lt;"], c:[">", "&gt;"], d:["\"", "&quot;"], e:["\xae", "&reg;"], f:["\xa9", "&copy;"], g:["\xd7", "&times;"], h:["\xf7", "&divide;"], k:["'", "&acute;"]};
	//k:["rn",'<br>']
	var ret = val;
	for (var o in specialChar) {
		var v = eval("specialChar." + o);
		try {
			ret = ret.replaceAll(v[0], v[1]);
		}
		catch (e) {
		}
	}
	return ret;
};

CommonClazz.createElement = function(id,as)
{
	var obj = document.createElement(id) ;
	if(!as) return obj ;
	var array = ['className' , 'cellSpacing' , 'cellPadding' , 'onclick','onchange','innerHTML'] ;
	for(var o in as){
		var v = eval('as.'+o) ;
		if(o == 'onclick'){
			obj.onclick = v ;
		}else if(o == 'onchange'){
			obj.onchange = v ;
		}else if(o == 'className'){
			obj.className = v ;
		}else if( inArray(array , o )){
			if( typeof(v) == 'function'){
				eval('obj.'+o+"="+v+"") ;
			}else{
				eval('obj.'+o+"='"+v+"'") ;
			}
		}else{
			obj.setAttribute(o , v) ;
		}
	}
	return obj ;
	
	function inArray(array ,a ){
		for(var i=0 ;i<array.length ;i++){
			if(array[i] == a) return true ;
		}
		return false ;
	}
}

/**[ {text:'',value''} ]*/
CommonClazz.createSelect = function(key_values)
{
	var select = $self.createElement("select") ;
	for(var i=0 ;i<key_values.length ;i++){
		var t = key_values[i] ;
		var o = $self.createElement("option",{value:t.value}) ;
		o.appendChild(document.createTextNode(t.text)) ;
		select.appendChild(o) ;
	}
	return select ;
}

/**获取javascript 函数名*/
CommonClazz.getFunctionName = function(fn)
{
	var name=/\W*function\s+([\w\$]+)\(/.exec(fn);
	if(!name)return '';
	return name[1];
}
CommonClazz.construct = function ($self, $class){
	this.initialize = function () {
	};	
}