/*
 * SimpleMap Object just like HashMap of Java
 *
 * 依赖 modello.js asu.common.asu-common.js
 */

//-----------------------------------------------------------
IAbstractMap = Class.create();
IAbstractMap.register("asu.utils.IAbstractMap");
IAbstractMap.construct = function() {
    this.put = Class.abstractMethod;
    this.get = Class.abstractMethod;
    this.size = Class.abstractMethod;
    this.clear = Class.abstractMethod;
    this.remove = Class.abstractMethod;
    this.keySet = Class.abstractMethod;
    this.entrySet = Class.abstractMethod;
    this.containKey = Class.abstractMethod;
    this.containValue = Class.abstractMethod;
}
//-----------------------------------------------------------

SimpleMap = Class.create("asu.utils.IAbstractMap");
SimpleMap.register("asu.utils.SimpleMap");

SimpleMap.construct = function($self, $class) {
	this.keys = new Array();
    this.entrys = new Array();
    this.data = new Array();
    this.type = 'SimpleMap';
    this.keySet = function () {
       return $self.keys;
    } ;
    this.entrySet = function ()  {
        return $self.entrys;
    } ;
    // put a mapping relation in map
	this.put = function (key,value)  {
		if ( CommonClazz.isNotEmpty(key) &&  CommonClazz.isNotEmpty(value))  {
			if ($self.containKey(key)) {
				var oldvalue = $self.data[key];
				$self.data[key] = value;
				var index = $self.entrySet().indexOf({"key":key, "value":oldvalue});
				$self.entrys.splice(index, 1);
				$self.entrySet().push({"key":key, "value":value});
			} else {
				$self.keySet().push(key);
				$self.data[key] = value;
				$self.entrySet().push({"key":key, "value":value});
			}
		 }
	};
	// return entry by the gaven key value
	this.get = function (key)  {
    	if (!$self.keys.include(key))
			return null;
		// assert data contains the key and value;
		return $self.data[key];
	};
	// return the size of the map
  	this.size = function ()  {
     	return $self.keySet().length;
	};
	// clear all    mapping records in the map
	this.clear = function ()  {
		$self.keys = new Array();
    	$self.entrys = new Array();
    	$self.data = new Array();
	};
	// return a mapping record from the map by the gaven key value
	this.remove = function (key)  {
	     var index = $self.keySet().indexOf(key);
	      if (index != - 1) {
	      	$self.keys.splice(index,1);

	      	var value = $self.data[key];
	      	index = $self.data.indexOf(value);
	      	$self.data.splice(index,1);

	      	var entry = {"key":key,"value":value};
	      	index = $self.entrySet().indexOf(entry);
	      	$self.entrys.splice(index,1);
	    }
	};
	// 判断是否有键，简单判断，不判断entrySet里是否有值
	this.containKey = function (key) {
		var index = $self.keySet().indexOf(key);
		if (index != - 1) {
			return true;
		} else {
			return false;
		}
	}
	// 判断是否有值，简单判断，不判断entrySet里是否有值
	this.containValue = function (value) {
		var index = $self.data.indexOf(key);
		if (index != - 1) {
			return true;
		} else {
			return false;
		}
	}
};





