XmlHelper = Class.create();
XmlHelper.construct = function($self, $class) {
	this.CreateXmlHttpRequest = function (){
		if(typeof XMLHttpRequest != 'undefined'){
		    return new XMLHttpRequest();
		}else if(window.ActiveXObject){
		    var aVersion = ['MSXML2.XMLHttp.6.0','MSXML2.XMLHttp.3.0','Microsoft.XMLHTTP'];
		    for(var i = 0; i < aVersion.length; i++){
		        try{
		            var oXHR = new ActiveXObject(aVersion[i]);
		            return oXHR;
		        }catch(oError){

		        }
		    }
		}
		throw new Error('XMLHttp object could not be created.');
	}

	/**
	 * 发送请求，获取xml
	 */
	this.xmlSend = function (strURL, xmlDoc, callBack) {
		var strDoc;
		var _callback;
		var innerXmlHttp = CreateXmlHttpRequest();
		if (xmlDoc != null && typeof(xmlDoc) == "object")
	  		strDoc = xmlDoc.xml;
	 	else
	  		strDoc = xmlDoc;

		var bAysync = false;

	 	if (callBack) {
	 		_callback = callBack;
	  		bAysync = true;
	  		innerXmlHttp.onreadystatechange = doCallback;
	 	}

	 	innerXmlHttp.open("POST", strURL, bAysync);
	 	innerXmlHttp.setRequestHeader("Content-Type","text/xml");

	 	innerXmlHttp.send(strDoc);

	 	if (bAysync)
	  		return innerXmlHttp;
	 	else  	{
	  		if (innerXmlHttp.responseXML.xml.length > 0)
	   			return innerXmlHttp.responseXML;
	  		else
			    return this.createErrorXML2(innerXmlHttp.responseText, "");
	 	}


	 	function doCallback(){
		  if(innerXmlHttp.readyState==4){
		      if(innerXmlHttp.status==200 || innerXmlHttp.status==304) {
		          _callback(innerXmlHttp.responseXML);
		      } else {
		         _callback(this.createErrorXML2( "抱歉，调用接口装载数据失败。原因："   +   innerXmlHttp.statusText ),"");
		      }
		    }
		}

	}


	/**
	 * 发送一般请求，直接获取返回的文本
	 */
	this.sendCommonHttpReq = function (strUrl) {
		var httpReq = this.CreateXmlHttpRequest();
		httpReq.open("POST" , strUrl , false);
		httpReq.send(null);
		return httpReq.responseText;
	}

	this.sendViaAjaxRequest = function(url, options) {
		/*
		options = {
	      method:       'post',
	      asynchronous: true,
	      contentType:  'application/x-www-form-urlencoded',
	      encoding:     'UTF-8',
	      parameters:   ''
	      onCreate: new function(transport){},
	      onComplete: new function(transport, json){},
	      onSuccess: new function(transport, json){},
	      onFailure: new function(transport, json){},
	      onException:new function(request, exception){}
	    }
		*/
		req = new Ajax.Request(url, options);
	}
	/**
	 * 根据string创建dom
	 */
	this.createDomDocument2 = function () {
		var xmlDom 	 = CreateXmlHttpRequest();
		xmlDom.async = false;
		if (arguments.length>0)
			xmlDom.loadXML(arguments[0]);

		return xmlDom;
	}

	/**
	 * 根据path创建dom
	 */
	this.createDomDocument = function () {
		var xmlDom 	 = CreateXmlHttpRequest();
		xmlDom.async = false;
		if (arguments.length>0)
			xmlDom.load(arguments[0]);

		return xmlDom;
	}

	/**
	 * 获取节点的值
	 */
	this.getNodeText = function (dom,path) {
		var node = dom.selectSingleNode(path);
	 	if (node)
	  		return node.text;
	 	else
	  		return "";
	};

	/*
	 *获取节点的属性值
	 */
	this.getNodeAttribute = function (node,attributeName) {
	 	var attr = node.attributes.getNamedItem(attributeName);
	 	if (attr)
	  		return attr.value;
	 	else
	  		return "";
	}

	this.appendNode = function (xmlDoc, root, strNodeName) {
		 var nodeText = "";

		 if (arguments.length > 3)
		   nodeText = arguments[3];

		 var node = xmlDoc.createNode(1, strNodeName, "");
		 if (nodeText.toString().length > 0)
		   node.text = nodeText;

		 root.appendChild(node);

		 return node;
	}

	this.createErrorXML2 = function (errValue, errStack) {
	 	var xmlDoc = createDomDocument2("<ResponseError/>");
	 	appendNode(xmlDoc, xmlDoc.documentElement, "message", errValue);
	 	appendNode(xmlDoc, xmlDoc.documentElement, "Stack", errStack);
	 	appendNode(xmlDoc, xmlDoc.documentElement, "Client", "true");
	 	return xmlDoc;
	}

	this.transform = function(dom,xslpath) {
		var xslt   = CreateXmlHttpRequest();
		xslt.async = false;
		xslt.load(xslpath);
		return dom.transformNode(xslt);
	}

}
Class.register(XmlHelper, "asu.utils.xml.XmlHelper");
//var xmlHelper = Class.get("asu.utils.xml.XmlHelper");